﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ELTE.Basics.University
{
    class Student // egyetemi hallgató típusa
    {
        private String _Name;
        private String _UniversityCode;
        private List<Course> _Courses;

        public Student(String name)
        {
            _Name = name;
            _UniversityCode = String.Empty;
            _Courses = new List<Course>();

            _UniversityCode = GenerateCode(name); // statikus művelet meghívása

            _ListOfStudents.Add(this); // statikus mezőhöz hozzáférés
        }

        public void SignForCourse(Course course)
        {
            course.AddStudent(this); // nyílt rekurzió
        }

        public String Name { get { return _Name; } }
        public String UniversityCode { get { return _UniversityCode; } }

        // statikus tagok:
        private static List<Student> _ListOfStudents = new List<Student>();

        private static String GenerateCode(String name) // kódgenerálás, amihez ismerni kell a többi oktató kódját is
        {
            String code = Char.ToUpper(name[0]) + Char.ToUpper(name[1])  + Char.ToUpper(name[name.IndexOf(' ') + 1]) + "PAAT.ELTE"; // kód generálása a név alapján
            Char modifierChar = 'A';
            foreach (Student s in _ListOfStudents)
            {
                if (code == s._UniversityCode) // ha találtunk ugyanolyan nazonosítójú oktatót
                {
                    modifierChar++; // akkor módosítjuk az egyik karaktert
                    code = Char.ToUpper(name[0]) + Char.ToUpper(name[1]) + Char.ToUpper(name[name.IndexOf(' ') + 1]) + "PA" + modifierChar + "T.ELTE";
                }
            }
            return code;
        }
    }
}
